# Python开发

## 1、概述
  通过通用集成开发环境进行Python项目开发。

## 2、环境准备
- 请先在系统中自行安装Python运行环境。
- Kylin Python插件安装   
  - 启动通用集成开发环境
  - 点击活动栏中的插件图标，调出插件视图。   
  - 点击插件视图中的插件筛选器图标，选择Kylin-IDE(KylinCode)插件分类->Python语言支持
  ![2-1](./resources/python/py-install.png "插件安装")
  - 通过以上步骤找到Python语言相关插件Kylin Python，点击插件右下角的安装图标进行安装操作
  - 安装成功后，重新加载窗口

# 快速开始

## 1、 创建Python项目
  - 在终端创建文件夹myProjectPython
  - 启动通用集成开发环境，点击文件->打开文件夹，选择myProjectPython
  - 点击新建文件图标，创建Python文件hello.py  
  ![2-2](./resources/python/py-createfile.png "创建项目")

## 2、 编辑
  - 在新建的hello.py文件中输入Python代码
    ```Python
    msg = "hello world"

    print(msg)
    ```
### 2.1、 自动补全、代码着色
    
   ![2-1](./resources/python/py-autocomplete.gif "代码补全")

### 2.2、 代码导航
  在编辑区的右键菜单中可以看到支持的代码导航,比如转到定义、转到实现、转到引用等   
  ![2-2](./resources/python/py-jump.gif "代码跳转")

## 3、 运行
  需要创建运行配置文件tasks.json，tasks.json文件被存储在.vscode文件夹内。创建方法如下：
  - 点击菜单中的终端->配置任务->使用模板创建tasks.json文件->others   
  - tasks.json文件创建成功    
    创建的tasks.json默认内容如下：
    ```json
    {
    // See https://go.microsoft.com/fwlink/?LinkId=733558
    // for the documentation about the tasks.json format
    "version": "2.0.0",
    "tasks": [
        {
            "label": "echo",
            "type": "shell",
            "command": "echo Hello"
        }
      ]
    }
    ```
  - 修改tasks.json文件，修改后内容如下：
    ```json
    {
    // See https://go.microsoft.com/fwlink/?LinkId=733558
    // for the documentation about the tasks.json format
    "version": "2.0.0",
    "tasks": [
        {
            "label": "run", //运行任务的名称
            "type": "shell",
            "command": "python",
            "args": ["hello.py"]
        }
      ]
    }
    ```
  - 点击菜单中的终端->运行任务->run->继续而不扫描任务输出,运行任务
  - 在终端输出运行结果    
   ![3-1](./resources/python/py-run.gif)

## 4、 调试
### 4.1、 一键调试
  对于一个简单的Python文件的调试，不需要进行配置，支持一键调试。    
  - 在hello.py文件左侧点击鼠标左键添加断点
  - 键盘按键F5   
  - 点击“Python File”   
    ![4-1](./resources/python/py-debug.gif "一键调试")

### 4.2、 自定义调试
  对于复杂的项目，需要创建调试配置文件launch.json，launch.json文件被存储在.vscode文件夹内。创建方法如下：
  - 点击菜单中的运行->添加配置,选择“Python File”    
  ![4-2](./resources/python/py-config-debug.png)   
  - launch.json文件创建成功    
    创建的launch.json默认内容如下：
    ```json
    {
        // 使用 IntelliSense 了解相关属性。 
        // 悬停以查看现有属性的描述。
        // 欲了解更多信息，请访问: https://go.microsoft.com/fwlink/?    linkid=830387
        "version": "0.2.0",
        "configurations": [
            {
                "name": "Python: Current File",
                "type": "python",
                "request": "launch",
                "program": "${file}",
                "console": "integratedTerminal",
                "justMyCode": true
            }
        ]
    }
    ```
    该launch.json文件配置可以调试myProjectPython,其他项目用户需要根据具体情况修改launch.json文件,例如修改调试文件：
    ```json
    "program": "${workspaceFolder}/hello.py",//修改调试文件
    ```
  - 在hello.py文件左侧点击鼠标左键添加断点
  - 点击左侧活动栏中的调试按钮，切换到调试视图   
  - 点击“Python: Current File”启动调试


