# 远程开发功能使用说明
## 功能概述
远程开发功能支持通过linux或windows客户端连接到远程机上进行代码开发功能，目前支持x86_64、loongarch64、aarch64三种架构。为用户提供远程编辑、远程编译、远程运行、远程调试等功能，linux和windows客户端上使用方法有所不同，具体使用方法如下：
- [Linux远程开发插件安装使用说明](#linux远程开发插件安装使用说明)
  - [准备工作](#1准备工作)
  - [插件安装](#2插件安装)
  - [远程资源管理](#3远程资源管理)
  - [连接管理](#4连接管理)
  - [项目管理、多语言开发、调试功能使用](#5项目管理多语言开发调试功能使用)
  - [远程开发环境卸载](#6远程开发环境卸载)
  - [例子](#7例子)
  - [浏览器导入证书方法](#8浏览器导入证书方法)
- [Windows远程开发使用说明](#windows远程开发使用说明)
  - [环境部署](#1环境部署)
  - [脚本执行](#2脚本执行)
## Linux远程开发插件安装使用说明
### 1、准备工作
  - 获取远程Linux主机的SSH用户和密码，查看远程主机的架构，是否属于x86_64、loongarch64、aarch64的其中一种，目前远程开发支持以上三种架构
  - 检查“远程机”的sshd服务是否正常，“/etc/ssh/sshd_config”中 “AllowTcpForwarding”和“PermitTunnel”为yes，如果“AllowTcpForwarding”和“PermitTunnel”为no，请修改配置，并重启sshd服务
  - 检查在客户机是否能够通过ssh连接到远程机
### 2、插件安装
- 从插件商店搜索`Kylin remote development`远程开发插件并安装

  ![图2-1](resources/kylin-remote-dev/remote-dev-install-from-open.png "通过插件商店安装插件")

- 安装完成后，将在左侧活动栏中出现远程开发插件图标，点击图标进入远程资源管理器页面
- 远程开发环境服务端软件包下载：
  - 根据远程机的架构，从gitee中选择对应架构的软件包进行下载(**下载版本 >= v0.1.2**)。[远程开发服务端软件包](https://gitee.com/mcy-kylin/kylin-ide-server/releases/) 
  - 将下载的软件包放在客户机本地环境中用户家目录下的.cache目录下  
  
  如： OpenKylin 操作系统、x86架构下需下载对应[kylin-ide-server_0.1.2_x86_64.tar.gz](https://gitee.com/mcy-kylin/kylin-ide-server/releases/download/v0.1.2/kylin-ide-server_0.1.2_x86_64.tar.gz)包，并放在客户机家目录下的.cache目录中(操作Kylin-IDE(KylinCode)进行插件安装的机器为客户机，不是要远程的机器)。

   
### 3、远程资源管理

- 在“远程资源管理器”中提供了查看设置、新建连接、刷新等功能：
- 查看设置:提供配置文件查看功能，点击后将在编辑区打开配置文件。
- 新建连接：提供连接添加功能
  - 点击添加按钮，弹出输入框，根据提示输入远程环境用户名@ip （该用户名是远程服务端真实存在的用户）
  - 在“远程资源管理器”中显示新增的连接
 
   ![图3-1](resources/kylin-remote-dev/remote-addconnect.gif "连接添加")
  
### 4、连接管理
- 新窗口打开：
  - 点击连接右边的“新窗口打开”图标
  - 在弹出输入框中，输入远程开发环境密码，将在新的窗口中打开远程开发环境（该密码为此连接在新建连接时输入的用户名对应的密码，用户名和密码是远程服务端真实存在的用户和登录密码）
 
  ![图4-1](resources/kylin-remote-dev/remote-openwindow.gif "新窗口打开")

- 右键菜单：将鼠标放置在连接上，点击鼠标右键，将弹出右键菜单；包括新窗口打开、浏览器打开、删除连接、重命名
  ![图4-2](resources/kylin-remote-dev/remote-menu.gif "右键菜单")
  - 新窗口打开效果同上步的新窗口打开图标

  - 浏览器打开：点击“浏览器打开”，在输入框中输入远程开发环境密码，将在浏览器中打开远程开发环境
  - 浏览器打开方式可能需要加载证书才能正常使用，具体方法见[浏览器导入证书方法](#8浏览器导入证书方法)

  ![图4-3](resources/kylin-remote-dev/remote-openweb.gif "浏览器打开")

  - 删除连接：将删除当前连接

  - 重命名：连接名默认显示ip地址，点击“重命名”可以对当前连接进行命名，方便用户记忆。

### 5、项目管理、多语言开发、调试功能使用
  - 通过远程开发插件打开远程开发环境后，其使用方法和Kylin-IDE(KylinCode)编辑器类似。
  - 插件安装
    - 打开远程开发环境后，可通过窗口上方标题显示的ip来区分所连接的远程环境与本地环境。
    - 远程开发环境插件的安装方法和Kylin-IDE(KylinCode)相同
    - 插件安装后，在“LOCALHOST:PORT-已安装”中显示远程开发环境已安装的插件

    ![图5-1](resources/kylin-remote-dev/remote-dev-install.gif "插件安装")
  - 项目管理
    - 项目管理功能使用方法请参见[项目管理章节](%E9%A1%B9%E7%9B%AE%E7%AE%A1%E7%90%86)

  - 多语言开发
    - 提供C、C++、Java、Python、Go、JavaScript语言的代码开发功能，包括代码编辑、编译、调试、运行等功能，具体使用条件和方法请参见[C-C++开发章节](./C-C%2B%2B%E5%BC%80%E5%8F%91.md)、[Java开发章节](./Java%E5%BC%80%E5%8F%91.md)、[Python开发章节](./Python%E5%BC%80%E5%8F%91.md)、[Go开发章节](./Go%E5%BC%80%E5%8F%91.md)、[JavaScript开发章节](./JavaScript%E5%BC%80%E5%8F%91.md)。

### 6、远程开发环境卸载
  - 服务端卸载
    - 检查远程机“server-main”服务进程是否存在，如果存在请杀死该进程，或等进程自动退出
    - 删除远程机用户目录下~/.kylin-ide-server 目录
    
  - 客户端卸载
    - 从Kylin-IDE(KylinCode)中卸载远程开发插件，同时删除用户目录下~/.kylin-ide-remote目录和~/.config/kylin-remote-ide目录
    

  - 注意：卸载操作旨在彻底清除环境中远程开发相关数据，可以用于版本升级或重装等操作，无需在每次使用完后进行卸载操作

 ### 7、例子
   - 假设A主机的用户“user1”，想远程到B主机“test”用户进行远程开发，则A主机即为客户端，B主机即为服务端
   - 使用远程开发的准备工作：
     - 登录A主机的“user”用户，启动Kylin-IDE(KylinCode)，并安装将远程插件
     - 根据B主机的架构类型，下载对应的远程开发服务端软件包，并将远程开发服务端软件包放在A主机的“user1”用户的.cache目录下 
     - 检查B主机的sshd服务是否正常，“/etc/ssh/sshd_config”中 “AllowTcpForwarding”和“PermitTunnel ” 为yes
     - 提供B主机的用户名“test”和密码“passwd”，检查在A上是否能够使用用户名test通过ssh连接到B
     
   - 新建连接
     - 点击新建连接图标，在输入框中输入“test@B主机ip”,该test为B主机中真实存在的用户
   - 新窗口打开
     - 点击新窗口打开图标，在输入框中输入test用户的密码，该密码为B主机中test用户的ssh登录密码
   - 服务端卸载
     - 上步新窗口打开使用的是test用户，则去B主机test用户下删除.kylin-ide-server目录，并确保“server-main”服务进程退出
   - 客户端卸载
     - 卸载Kylin-IDE/Kylin-Code中的远程开发插件，并删除A主机用户“user1”目录下的.kylin-ide-remote目录
    
### 8、浏览器导入证书方法

   - 证书导入原因
     - 通过浏览器方式打开远程开发环境时，WebView有时无法加载
        - 浏览器需要通过https方式登录远程开发环境，并使用service worker缓存加载WebView资源；在采用Chrome内核的浏览器中，service worker必须使用受信任的证书才能注册成功，否则WebView就无法加载; Firefox浏览器只需点击前往不信任地址便可直接访问。所以，针对采用Chrome内核的浏览器需要手动导入证书。
   - 国产平台导入证书的方法
     - 证书位置 ~/.kylin-ide-remote/kylinideca.pem，由于打开目录不一定能识别隐藏目录，可先将证书拷贝到非隐藏目录下 如 ~/kylinideca.pem   
     - Chrome浏览器
        - 选择'设置' -> '隐私设置和安全性' -> '安全'

        ![8-1](resources/kylin-remote-dev/chrome1.png "Chrome导入证书")

        - 选择'管理证书'

        ![8-2](resources/kylin-remote-dev/chrome2.png "Chrome导入证书")

        - 选择'授权机构' -> '导入' -> 选择您另存的kylinideca.pem文件

        ![8-3](resources/kylin-remote-dev/chrome3.png "Chrome导入证书")
        
        - 选择'信任该证书，以标识网站的身份'选项

        ![8-4](resources/kylin-remote-dev/chrome4.png "Chrome导入证书")

        - 清理浏览器缓存后，重启浏览器并再次打开远程连接      

        ![8-5](resources/kylin-remote-dev/chrome5.png "Chrome导入证书")  

     - 火狐浏览器
        
        - 选择'设置' -> '隐私与安全' -> '查看证书'
        
        ![8-6](resources/kylin-remote-dev/firefox1.png "Firefox导入证书")

        - 选择'证书颁发机构' -> '导入'

        ![8-7](resources/kylin-remote-dev/firefox2.png "Firefox导入证书")

        - 选择您另存的kylinideca.pem证书文件后， 选择信任标识网站，清理缓存后重启再次打开远程连接即可

        ![8-8](resources/kylin-remote-dev/firefox3.png "Chrome导入证书")

     - 奇安信浏览器
        - 选择'设置' -> '可信安全' -> '管理可信证书'

        ![8-9](resources/kylin-remote-dev/qianxin1.png "奇安信导入证书")

        - 选择'导入证书'，导入后清理浏览器缓存并重启浏览器再次打开远程连接即可

        ![8-10](resources/kylin-remote-dev/qianxin2.png "奇安信导入证书") 
     - 龙芯浏览器
        - 选择'设置' -> '隐私设置和安全性' -> '安全'

        ![8-11](resources/kylin-remote-dev/loong1.png "Chrome导入证书")

        - 选择'管理证书'

        ![8-12](resources/kylin-remote-dev/loong2.png "Chrome导入证书")

        - 选择'授权机构' -> '导入' -> 选择您另存的kylinideca.pem文件

        ![8-13](resources/kylin-remote-dev/loong3.png "Chrome导入证书")

        - 选择'信任该证书，以标识网站的身份', 清理浏览器、重启浏览器并再次打开远程连接

        ![8-14](resources/kylin-remote-dev/loong4.png "Chrome导入证书")
     - 360浏览器
        - 选择'设置' -> '安全隐私' -> '证书管理'
        
        ![8-15](resources/kylin-remote-dev/3601.png "Chrome导入证书")

        - 选择'授权机构' -> '导入' -> 选择您另存的kylinideca.pem文件

        ![8-16](resources/kylin-remote-dev/3602.png "Chrome导入证书")

        - 选择'信任该证书，以标识网站的身份'，清理浏览器缓存、重启浏览器并再次打开远程连接
        
        ![8-17](resources/kylin-remote-dev/3603.png "Chrome导入证书")

## Windows远程开发使用说明
### 1、环境部署
  - 获取远程Linux主机的SSH用户和密码，查看远程主机的架构，是否属于x86_64、loongarch64、aarch64的其中一种，目前远程开发支持以上三种架构
  - 检查“远程机”的sshd服务是否正常，“/etc/ssh/sshd_config”中 “AllowTcpForwarding”和“PermitTunnel”为yes，如果“AllowTcpForwarding”和“PermitTunnel”为no，请修改配置，并重启sshd服务
  - 检查在客户机是否能够通过ssh连接到远程机
  - 脚本下载：
    从[windows远程开发脚本下载地址](https://gitee.com/openkylin/extensions-repo.git/) 下载KylinIDETEeam/remote-dev/目录下的kylin-ide-server-build.sh和kylin-remote-start.exe文件
    
  - 远程开发环境服务端软件包下载：
    - 根据远程机的架构，从gitee中选择对应架构的软件包进行下载(**下载版本 >= v0.1.2**)。[远程开发服务端软件包](https://gitee.com/mcy-kylin/kylin-ide-server/releases/) ，如： OpenKylin 操作系统、x86架构下需下载对应[kylin-ide-server_0.1.2_x86_64.tar.gz](https://gitee.com/mcy-kylin/kylin-ide-server/releases/download/v0.1.2/kylin-ide-server_0.1.2_x86_64.tar.gz)包
    - 将下载的软件包和kylin-ide-server-build.sh脚本放在远程机的同一个目录下，如：~/test/
    - 为kylin-ide-server-build.sh脚本设置`可执行权限`。
  - 将kylin-remote-start.exe脚本放在windows客户端目录下

  ### 2、脚本执行
  - kylin-remote-start.bat脚本执行：
    - 将脚本放在windows客户端上后，通过cmd启动windows命令终端，进入脚本所在目录执行该脚本,格式如下：

      `  kylin-remote-start.exe [远程用户名] [远程环境ip] [远程环境kylin-ide-server-build.sh脚本所在目录]`
   
    - 执行脚本后输入远程机密码，如下图所示：

      ![9-1](resources/kylin-remote-dev/windows1.png "启动bat脚本")

    - 根据提示在新的弹窗中再次输入远程机密码，此次输入密码是为了建立隧道，使用过程中请勿关闭该窗口。（如果未弹出窗口或超时，请重新bat执行脚本）
      ![9-2](resources/kylin-remote-dev/windows2.png "创建隧道")

 - 脚本执行成功后会自动打开浏览器，远程开发环境启动完成

