"use strict";
/*
 * @Author: Kylinos
 * @Date: 2022-02-21 11:44:01
 * @LastEditors: Kylinos
 * @LastEditTime: 2022-02-25 18:08:34
 * @FilePath: /vscode-package-builder/src/manager/mkshowCommands.ts
 * @Description:
 * Deb打包相关命令所有实现逻辑
 * Copyright (c) 2022 by Kylinos, All Rights Reserved.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.editpriview = exports.Refresh = exports.CreateDefaultDir = void 0;
const commandBase_1 = require("./commandBase");
const vscode = require("vscode");
const path = require("path");
const tvProvider_1 = require("./tvProvider");
/**
 * Deb打包命令实现逻辑
 */
function refresh1() {
    return __awaiter(this, void 0, void 0, function* () {
        let debTreeProvider = tvProvider_1.MyTreeDataManager.getInstance().getTreeData('mkshow');
        yield debTreeProvider.refresh();
    });
}
/**
 * 创建markdown-help默认工作区
 */
class CreateDefaultDir extends commandBase_1.CommandAbstract {
    constructor(context) {
        super('mkshow.createDefaultDir', context);
    }
    /**
     * @description: 在用户home目录下创建debbuild目录用来保存需要构建的软件包,同时设置将deb treeview的根目录为该目录
     * @param {any} arg
     * @return {*}
     */
    process(arg) {
        let get_mkdown = path.join(this.context.extensionPath, 'get_markdown');
        tvProvider_1.MyTreeDataManager.getInstance().getTreeData('mkshow').setRoot(get_mkdown);
    }
}
exports.CreateDefaultDir = CreateDefaultDir;
//定义deb sections列表
const sections = `admin
comm
contrib/utils
database
debug
default
devel
doc
editors
fonts
games
gnome
graphics
interpreters
introspection
java
javascript
kernel
libdevel
libs
lisp
localization
mail
math
metapackages
misc
net
non-free/admin
non-free/fonts
oldlibs
otherosfs
perl
python
shells
sound
text
translations
utils
vcs
video
web
x11`;
/**
 * treeview刷新命令
 */
class Refresh extends commandBase_1.CommandAbstract {
    constructor(context) {
        super('mkshow.refresh', context);
    }
    process(theNode) {
        tvProvider_1.MyTreeDataManager.getInstance().getTreeData('mkshow').refresh();
    }
}
exports.Refresh = Refresh;
class editpriview extends commandBase_1.CommandAbstract {
    constructor(context) {
        super('mkshow.editpriview', context);
    }
    process(theNode) {
        vscode.commands.executeCommand('markdown.showPreview');
    }
}
exports.editpriview = editpriview;
//# sourceMappingURL=mkshowCommands.js.map